Bug 1037177 - lingot FTBFS if "-Werror=format-security" flag is used
Summary: lingot FTBFS if "-Werror=format-security" flag is used
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: lingot
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Karel Volný
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1106098
TreeView+ depends on / blocked
 
Reported: 2013-12-03 03:18 UTC by Dhiru Kholia
Modified: 2014-07-01 00:15 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-12-04 10:43:00 UTC
Type: ---


Attachments (Terms of Use)

Description Dhiru Kholia 2013-12-03 03:18:50 UTC
Description of problem
----------------------

lingot fails to build if "-Werror=format-security" flag is used.

...

lingot-gui-mainframe.c:245:8: error: format not a string literal and no format arguments [-Werror=format-security]

...

We are working on a proposal to enable "-Werror=format-security" for all
packages. Once this flag is enabled, GCC will refuse to compile code that could
be vulnerable to a string format security flaw. For more details, please see
https://fedorahosted.org/fesco/ticket/1185 page.

To understand why it is important to fix this, please see
https://fedoraproject.org/wiki/Format-Security-FAQ page.

How to fix this
---------------

The fix for these errors is quite simple. It's a matter of changing a
line like,

   printf(foo);

to read,

   printf("%s", foo);

That's it.

Please fix this issue in rawhide with a patch (which you should submit
to upstream to merge moving forward). Please do a new build with the
fix in rawhide. Other releases do not need to be directly fixed, but
there should be no harm in pushing out this fix/patch with other needed
changes to those branches.

In the event you don't fix this bug before the next mass rebuild,
provenpackagers may step in and update your package(s) to fix this
issue.

How reproducible
----------------

Build lingot-0.9.1-6.fc20.src.rpm with "-Werror=format-security" flag to reproduce the problem.

To make this process easier, you can use a modified "redhat-rpm-config" package
from http://people.fedoraproject.org/~halfie/artifacts/redhat-rpm-config/ URL.

$ sha256sum redhat-rpm-config-9.1.0-56.fc20.*
faad7594b2080fe76497d0ce50808c905a93dd7b41c1defdde5ca57e3833d3d2  redhat-rpm-config-9.1.0-56.fc20.noarch.rpm
5aa9357174305c7285ffdbc92d7ffe1c07a8a95d5459b930461308f5aad75413  redhat-rpm-config-9.1.0-56.fc20.src.rpm

Comment 1 Karel Volný 2013-12-04 10:43:00 UTC
the code in question got changed in lingot upstream already, version 0.9.2 is about to be released and I plan to update the Fedora package as soon as the new tarball gets released

I see no point in patching the obsolete version; generally, I think this change has been planned very poorly, saying "you have to fix it now! as in three weeks your builds will start to fail" without any respect to upstream release cycles, especially when the change is quite questionable[*], seems to me a bit shortsighted, to put it mildly

[*] e.g. https://fedorahosted.org/fesco/ticket/1185#comment:19

Comment 2 Karel Volný 2013-12-04 10:46:04 UTC
p.s. and of course, I really do not see any security problem related to the reported error in the current version 0.9.1, false positive IMO


Note You need to log in before you can comment on or make changes to this bug.